#!/usr/local/bin/perl
#### եHTTPեץ mkup.pl V3.00 
#### Copyright 1998-2004 GORRY. 
#### mailto: gorry@hauN.org 
#### 
#### History: 
#### 2004/05/14 V3.00 С󳫻ϡ
#### 2000/11/07 V2.20 ѥ᡼ִб
####                  ξǼ³Τʤ顼åɽХ
#### 2000/09/20 V2.11 sjisƥȤǤʤեबɽʤХ
#### 2000/03/12 V2.02 chmod 666chmod o+wѹ
#### 2000/01/12 V2.01 GETDIRб
#### 1999/09/30 V2.00 ˥塼롣
#### 1999/09/26 V1.15 ưΥ顼Фʤ褦
#### 1998/12/16 V1.03 prev/today/nextб
#### 1998/12/15 V1.02 ǽεưǤΤȤlastuploadեդǵư褦ˤ
#### 1998/12/14 V1.01 ƥȥ⡼ɡʹ˷ɽˤɲá
####                  եιб 
#### 1998/12/13 V1.00  

require "libgns.pl";

$NKFCODE_MKUP = '-e';  # EUC-JP˸

{
	$argc = $#ARGV+1;

	&Setup();

	$command = "";
	$pass = "";
	if ( $argc >= 4 ) {
		$pass = $ARGV[4];
	}
	if ( $argc >= 3 ) {
		$command = $ARGV[3];
	}
	if ( $argc >= 2 ) {
		$year = $ARGV[0];
		$month = $ARGV[1];
		$day = $ARGV[2];
		if ( ($month == 99) && ($day == 99) ) {
			$diary = sprintf( $KEEPDIR . $SLASH . '%02d.html', $year );
		} else {
			if ( ($year == 0) && ($month == 0) && ($day == 0) ) {
				$lastupload = $KEEPDIR . $SLASH . $LASTUPLOADNAME;
				open( FIN, $lastupload );
				$line = <FIN>;
				( $year, $month, $day ) = split( " ", $line );
				close( FIN );
				if ( $year == 0 ) {
					@today = localtime( time );
					$year = $today[5];
					$month = $today[4]+1;
					$day = $today[3];
					$umaskback = umask( oct($DIARY_KEEP_PERM) ^ 0666 );
					open( FOUT, ">$lastupload" );
					print FOUT "$year, $month, $day\n";
					close( FOUT );
					umask( $umaskback );
				}
				if ( $year >= 1980 ) {
					system( "$PERLCMD mkd.pl $year $month $day test" );
				}
			}
			if ( $command eq 'prev' ) {
				&YMD2DAYS( $year, $month, $day );
				&DAYS2YMD( $TOTALDAYS-1 );
				$year = $YEAR;
				$month = $MONTH;
				$day = $DATE;
			} elsif ( $command eq 'next' ) {
				&YMD2DAYS( $year, $month, $day );
				&DAYS2YMD( $TOTALDAYS+1 );
				$year = $YEAR;
				$month = $MONTH;
				$day = $DATE;
			}
			$diary = sprintf( $GETDIR . $SLASH . '%04d' . $SLASH . '%02d%02d.html',
			  $year, $month, $day
			);
			&GetDiaryPart( $year, $month, $day );
			$part = $PART;
		}
	}

	&ReadLastUpload();
	$makeindex = $LASTUPLOAD{"makeindex"}+0;

	$mkup = $NKFCMD . ' -e mkup.html |';
	$fout = "|" . $NKFCMD . ' ' . $NKFCODE_MKUP;
	open( FIN, $mkup );
	open( FOUT, $fout );

	while ( $line = <FIN> ) {
		$line = &Replace( $line, $year, $month, $parts, $day );
		if ( $line =~ m:\@/MKUP_SOURCE/: ) {
			if ( $diary ne '' ) {
				if ( -e $diary ) {
					$cmd = $NKFCMD . ' -e ' . $diary . "|";
					open( FIN2, $cmd );
					while ( $line2 = <FIN2> ) {
						$line2 =~ s/[&]/\&amp;/g;
						print FOUT $line2;
					}
					close( FIN2 );
				}
			}
			next;
		}
		if ( $line =~ m:\@/MKUP_BODY/: ) {
			$cmd = $NKFCMD . ' -e ' . $TMPDIR . $SLASH . 'test.html |';
			open( FIN2, $cmd );
			while ( $line2 = <FIN2> ) {
				print FOUT $line2;
			}
			close( FIN2 );
			next;
		}
		if ( $line =~ m:\@/MKUP_PASS/: ) {
			if ($pass ne '') {
				$line =~ s:\@/MKUP_PASS/:$pass:g;
			}
		}
		if ( $line =~ m:\@/MKUP_MAKEINDEX/: ) {
			if ($makeindex) {
				$line =~ s:\@/MKUP_MAKEINDEX/:checked:g;
			} else {
				$line =~ s:\@/MKUP_MAKEINDEX/::g;
			}
		}
		print FOUT $line;
	}
	close( FOUT );
	close( FIN );

}

0;
# [EOF]
