#!/usr/local/bin/perl
#### ե mkidx.cgi V3.00 
#### Copyright 1998-2004 GORRY. 
#### mailto: gorry@hauN.org 
#### 
#### History: 
#### 2004/05/14 V3.00  

require 'config.ph';
require 'jcode.pl';

{
	print "Content-Type: text/html; charset=EUC-JP\n\n";
	open( SAVEERR, ">&STDERR" );
	open( STDERR, ">$TMPDIR/cgierr.log" );
	select( STDERR ); $| = 1; select( STDOUT );
	eval {
		&main();
	};
	if ( $@ ) {
		print STDERR $@;
	}
	close( STDERR );
	open( STDERR, ">&SAVEERR" );
}
1;

sub main {

	if ( $ENV{'REQUEST_METHOD'} eq "POST" ) {
		$len = $ENV{'CONTENT_LENGTH'} + 0;
		read( STDIN, $str, $len );
	} else {
		$str = $ENV{'QUERY_STRING'};
	}

	@part = split( '&', $str );
	foreach $i (@part) {
		( $variable, $value ) = split( '=', $i );
		$value =~ tr/+/ /;
		$value =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C", hex($1))/eg;
		&jcode'convert( *value, 'sjis' );
		$value =~ s/\015\012/\012/g;
		$value =~ s/\015/\012/g;
		if ( $cgi{$variable} eq "" ) {
			$cgi{$variable} = $value;
		} else {
			$cgi{$variable} .= "," . $value;
		}
	}

	$year = $cgi{ 'year' };
	$year = $year+0;
	if ( $year == 0 ) {
		($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
		$year += 1900;
	}

	if ( !(-e "$GETDIR/$year") ) {
		&printerror( "$yearǯΥե¸ߤƤޤ̤ǯꤷƤ" );
		exit;
	}

	$cmd = "$PERLCMD mkidx.pl $year";
	if ( system( $cmd ) ) {
		&printerror( "[$cmd]μ¹ԥ顼ȯޤ" );
		exit;
	}

	&message( "<A HREF=\"$PUTDIR/${year}.html\">$yearǯΰ</A>ޤ" );
	exit;

}

sub message {
	local( $msg ) = shift;

	print <<message;
<HTML><HEAD>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=EUC-JP">
<META HTTP-EQUIV="Content-Language" CONTENT="ja">
<TITLE>GNS κ</TITLE></HEAD><BODY>
<H1>GNS κ</H1>
<HR>
<DIV>$msg</DIV>
<HR>
<DIV><A HREF="mkidx.html">[]</A>
</BODY></HTML>
message
}

sub printerror {
	local( $msg ) = shift;

	&message( $msg );
}
