#!/usr/local/bin/perl
#### ե᡼ȯץ postmail.awk V3.00
#### Copyright 1998-2004 GORRY. 
#### mailto: gorry@hauN.org 
#### 
#### History: 
#### 2004/05/14 V3.00 С󳫻ϡ
#### 2000/07/05 V2.10 config.awkѤ˽
#### 2000/01/12 V2.01 GETDIRб
#### 1999/09/30 V2.00 ˥塼롣
#### 1998/12/17 V1.04 

require "libgns.pl";

$mailsendcmd = $MAILCMD . " -s \"" . $MAILSUBJECT;

{
	$argc = $#ARGV;

	if ( $argc >= 4 ) {
		$pass = $ARGV[4];
	}
	if ( $argc >= 3 ) {
		$command = $ARGV[3];
	}
	if ( $argc >= 2 ) {
		$year = $ARGV[0];
		$month = $ARGV[1];
		$day = $ARGV[2];
		if (($month == 99) && ($day == 99)) {
			$diary = sprintf( $KEEPDIR . $SLASH . '%02d.html', $year );
		} else {
			if ( ($year == 0) && ($month == 0) && ($day == 0) ) {
				$lastupload = $KEEPDIR . $SLASH . $LASTUPLOADNAME;
				open( FIN, $lastupload );
				$line = <FIN>;
				( $year, $month, $day ) = split( " ", $line );
				close( FIN );
				if ( $year >= 1980 ) {
#					system( "$PERLCMD mkd.pl $year $month $day test" );
				}
			}
			$diary = sprintf( $GETDIR . $SLASH . '%04d' . $SLASH . '%02d%02d.html',
			  $year, $month, $day
			);
		}
	}

	if ( $diary eq '' ) {
		print "diary file is not specified.\n";
		last;
	}
	if ( !(-e $diary) ) {
		print "diary file [$diary] not found.\n";
		last;
	}
	$date = sprintf( '%04d%02d%02d', $year, $month, $day );

	( $sec_2,$min_2,$hour_2,$mday_2,$mon_2,$year_2,$wday_2,$yday_2,$isdst ) = localtime( time );
	$year_2 += 1900;
	$mon_2 += 1;
	$timestamp = sprintf( "%04d/%02d/%02d %02d:%02d:%02d", $year_2, $mon_2, $mday_2, $hour_2, $min_2, $sec_2 );
	$cmd = "| $NKFCMD $NKFCODE | $MAILCMD -s \"$MAILSUBJECT $date $timestamp\" $MAILTO";
# print "$cmd\n";
	open( CMD, $cmd ) || die "cannot execute [$cmd].";
	printf( CMD "01 %04d %02d %02d %s\n", $year, $month, $day, $pass );
	print CMD "#OVER\n";
	print CMD "\n";
	open( FIN, $diary ) || die "cannot open [$diary].";
	while ( $line2 = <FIN> ) {
		print CMD $line2;
	}
	close( FIN );
	close( CMD );
}

0;
# [EOF]
